// http://zx-pk.ru/showthread.php?t=19960 //

#include <stdio.h>
#include <windows.h>   
#include "vsm.hpp"   

#define SIZE_X  640
#define SIZE_Y  514

/********************************************************************/

class DISPLAY : public IACTIVEMODEL,public IDSIMMODEL 
{ 
public: 
  int isdigital (CHAR *pinname); 
  void setup (IINSTANCE *inst, IDSIMCKT *dsim); 
  void runctrl (RUNMODES mode); 
  void actuate (REALTIME time, ACTIVESTATE newstate); 
  BOOL indicate (REALTIME time, ACTIVEDATA *data); 
  void simulate (ABSTIME time, DSIMMODES mode); 
  void callback (ABSTIME time, EVENTID eventid); 
  void initialize (ICOMPONENT *cpt); 
  ISPICEMODEL *getspicemodel (CHAR *device); 
  IDSIMMODEL *getdsimmodel (CHAR *device); 
  void plot (ACTIVESTATE state); 
  void animate (INT element, ACTIVEDATA *newstate); 
  BOOL actuate (WORD key, INT x, INT y, DWORD flags); 
 
private: 
  IINSTANCE *instance;  
  IDSIMCKT *ckt;      
  ICOMPONENT *component;   
  IDSIMPIN *en_R; 
  IDSIMPIN *en_G; 
  IDSIMPIN *en_B; 
  IDSIMPIN *en_I; 
  IDSIMPIN *en_sync_h; 
  IDSIMPIN *en_sync_v; 
  IDSIMPIN *en_pclk; 
}; 

HANDLE hProcessHeap;
HDC dc,buffer;
HBITMAP bmp;
PCHAR lin,slin;
int fsize=0,lsize=0;
BOOL vst, hst, plst;
HWND hpupwnd=0;              
BITMAPINFO bmi;
UCHAR colort[]={0,5,10,15,20,25,30,35,40,45,50,55,60,65,70,75};

IUSERPOPUP  *pup;
IMSGHLR * cbf;


extern "C" IDSIMMODEL __declspec(dllexport)*createdsimmodel(CHAR *device,ILICENCESERVER *ils)   {     
        ils->authorize(0x88888888, 0x69);  
        return new DISPLAY;   
}   
       

extern "C" VOID __declspec(dllexport)deletedsimmodel(IDSIMMODEL*model)   {   
    HeapFree(hProcessHeap,0,lin);
    HeapFree(hProcessHeap,0,slin);
    delete (DISPLAY*)model; 
  if (pup!=NULL) delete cbf;
  delete pup;
}   
       
       
int DISPLAY::isdigital(CHAR *pinname)   {   
        return 1;   
}   

class WINCB : public IMSGHLR
{
public:
  LRESULT msghlr(HWND, MESSAGE, WPARAM, LPARAM);

};

LRESULT WINCB::msghlr(HWND hwnd, MESSAGE msg, WPARAM wParam, LPARAM lParam)
{
  if (!hpupwnd)
  {
    hpupwnd = hwnd;

    dc = GetDC(hwnd);
    buffer = CreateCompatibleDC(dc);
    ReleaseDC(hwnd, dc);

    bmi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);

    bmi.bmiHeader.biWidth = SIZE_X;
    bmi.bmiHeader.biHeight = SIZE_Y;
    bmi.bmiHeader.biPlanes = 1;
    bmi.bmiHeader.biBitCount = 8;
    bmi.bmiHeader.biCompression = BI_RGB;
    bmi.bmiHeader.biSizeImage = 0;
    bmi.bmiHeader.biXPelsPerMeter = 0;
    bmi.bmiHeader.biYPelsPerMeter = 0;
    bmi.bmiHeader.biClrUsed = 0;
    bmi.bmiHeader.biClrImportant = 0;

    //0000
    bmi.bmiColors[0x0].rgbRed = 0;
    bmi.bmiColors[0x0].rgbGreen = 0;
    bmi.bmiColors[0x0].rgbBlue = 0;
    bmi.bmiColors[0x0].rgbReserved = 0;
    //0001
    bmi.bmiColors[5].rgbRed = 200;
    bmi.bmiColors[5].rgbGreen = 0;
    bmi.bmiColors[5].rgbBlue = 0;
    bmi.bmiColors[5].rgbReserved = 0;
    //0010
    bmi.bmiColors[10].rgbRed = 0;
    bmi.bmiColors[10].rgbGreen = 200;
    bmi.bmiColors[10].rgbBlue = 0;
    bmi.bmiColors[10].rgbReserved = 0;
    //0011
    bmi.bmiColors[15].rgbRed = 200;
    bmi.bmiColors[15].rgbGreen = 200;
    bmi.bmiColors[15].rgbBlue = 0;
    bmi.bmiColors[15].rgbReserved = 0;
    //0100
    bmi.bmiColors[20].rgbRed = 0;
    bmi.bmiColors[20].rgbGreen = 0;
    bmi.bmiColors[20].rgbBlue = 200;
    bmi.bmiColors[20].rgbReserved = 0;
    //0101
    bmi.bmiColors[25].rgbRed = 200;
    bmi.bmiColors[25].rgbGreen = 0;
    bmi.bmiColors[25].rgbBlue = 200;
    bmi.bmiColors[25].rgbReserved = 0;
    //0110
    bmi.bmiColors[30].rgbRed = 0;
    bmi.bmiColors[30].rgbGreen = 200;
    bmi.bmiColors[30].rgbBlue = 200;
    bmi.bmiColors[30].rgbReserved = 0;
    //0111
    bmi.bmiColors[35].rgbRed = 200;
    bmi.bmiColors[35].rgbGreen = 200;
    bmi.bmiColors[35].rgbBlue = 200;
    bmi.bmiColors[35].rgbReserved = 0;
    //1000
    bmi.bmiColors[40].rgbRed = 0;
    bmi.bmiColors[40].rgbGreen = 0;
    bmi.bmiColors[40].rgbBlue = 0;
    bmi.bmiColors[40].rgbReserved = 0;
    //1001
    bmi.bmiColors[45].rgbRed = 255;
    bmi.bmiColors[45].rgbGreen = 0;
    bmi.bmiColors[45].rgbBlue = 0;
    bmi.bmiColors[45].rgbReserved = 0;
    //1010
    bmi.bmiColors[50].rgbRed = 0;
    bmi.bmiColors[50].rgbGreen = 255;
    bmi.bmiColors[50].rgbBlue = 0;
    bmi.bmiColors[50].rgbReserved = 0;
    //1011
    bmi.bmiColors[55].rgbRed = 255;
    bmi.bmiColors[55].rgbGreen = 255;
    bmi.bmiColors[55].rgbBlue = 0;
    bmi.bmiColors[55].rgbReserved = 0;
    //1100
    bmi.bmiColors[60].rgbRed = 0;
    bmi.bmiColors[60].rgbGreen = 0;
    bmi.bmiColors[60].rgbBlue = 255;
    bmi.bmiColors[60].rgbReserved = 0;
    //1101
    bmi.bmiColors[65].rgbRed = 255;
    bmi.bmiColors[65].rgbGreen = 0;
    bmi.bmiColors[65].rgbBlue = 255;
    bmi.bmiColors[65].rgbReserved = 0;
    //1110
    bmi.bmiColors[70].rgbRed = 0;
    bmi.bmiColors[70].rgbGreen = 255;
    bmi.bmiColors[70].rgbBlue = 255;
    bmi.bmiColors[70].rgbReserved = 0;
    //1111
    bmi.bmiColors[75].rgbRed = 255;
    bmi.bmiColors[75].rgbGreen = 255;
    bmi.bmiColors[75].rgbBlue = 255;
    bmi.bmiColors[75].rgbReserved = 0;

    bmp = CreateDIBSection(buffer, &bmi, DIB_RGB_COLORS, (void**)slin, NULL, 0);

    SelectObject(buffer, bmp);
  }

  return pup->callwindowproc(msg, wParam, lParam);
  
}

/********************************************************************/

void DISPLAY::setup(IINSTANCE *inst,IDSIMCKT *dsim)   {   
    instance = inst;    
          ckt = dsim;     
        
//    instance->log("START");
    hProcessHeap=GetProcessHeap();
    lin=(PCHAR)HeapAlloc(hProcessHeap, 0, SIZE_X*10*SIZE_Y); 
    slin=(PCHAR)HeapAlloc(hProcessHeap, 0, SIZE_X*10*SIZE_Y); 
    hpupwnd=0;
  CREATEPOPUPSTRUCT *cp=new CREATEPOPUPSTRUCT;
  cp->caption = "TV SCREEN";
  cp->id = 0;
  cp->type = PWT_USER;
  cp->flags = PWF_VISIBLE; // | PWF_AUTOREFRESH;
  cp->width = SIZE_X;
  cp->height = SIZE_Y;

  pup = (IUSERPOPUP*)instance->createpopup(cp);
  if (pup!=NULL)
  {
  cbf = new WINCB;
  pup->setmsghlr(cbf);
  }   
    en_R = instance->getdsimpin("R,r", true);   
        en_R->setstate(FLT);   
    en_G = instance->getdsimpin("G,g", true);   
        en_G->setstate(FLT);   
    en_B = instance->getdsimpin("B,b", true);   
        en_B->setstate(FLT);   
    en_I = instance->getdsimpin("I,i", true);   
        en_I->setstate(FLT);   
    en_sync_h = instance->getdsimpin("SSI", true);   
        en_sync_h->setstate(FLT);   
    en_sync_v = instance->getdsimpin("KSI", true);   
        en_sync_v->setstate(FLT);   
    en_pclk = instance->getdsimpin("PCLK", true);   
        en_pclk->setstate(FLT);   
        
}   
       
void DISPLAY::runctrl(RUNMODES mode)  {   
//          instance->log("mode %d",mode);

}   
       
       
void DISPLAY::actuate(REALTIME time,ACTIVESTATE newstate) {   
//  MessageBox(0, "ACTUATE 1", "Break", MB_OK);

}   
       
BOOL DISPLAY::indicate(REALTIME time,ACTIVEDATA *data)   {      
//    instance->log("indicate");
  SetBitmapBits(bmp, SIZE_X*SIZE_Y, lin);
  dc = GetDC(hpupwnd);
  BitBlt(dc, 0, 0, SIZE_X, SIZE_Y, buffer, 0, 0, SRCCOPY);
  ReleaseDC(hpupwnd, dc);
  return TRUE;
}   
       
       
void DISPLAY::simulate (ABSTIME time,DSIMMODES mode) {      
  int i;
    UCHAR c;
    BOOL st_pc=en_pclk->isposedge();

    BOOL st_R=ishigh(en_R->istate());
    BOOL st_G=ishigh(en_G->istate());
    BOOL st_B=ishigh(en_B->istate());
    BOOL st_I=ishigh(en_I->istate());
    BOOL st_SSI=ishigh(en_sync_h->istate());
    BOOL st_KSI=ishigh(en_sync_v->istate());

  if (st_KSI==0) return; else 
  { if(en_sync_v->isposedge()) 
   { 
//    instance->log("- KSI begin -"); 
    fsize=0; 
    lsize=0;
   } 
  }
  if (st_SSI==0) return; else 
  { if(en_sync_h->isposedge()) 
   {
//    instance->log("SSI begin %d %d",lsize, fsize/SIZE_X);
    fsize+=SIZE_X;
    lsize=0;       
    if (fsize>=SIZE_X*SIZE_Y) fsize=0;
     for (i=0;i<SIZE_X;i++) 
   {
       *(lin + fsize + SIZE_X + i) = 75;
   }
   } 
  }
  if (st_pc==0) return;
//    instance->log("SSI %d %d",lsize, fsize/SIZE_X);

  if (st_R) c=1; else c=0;
  if (st_G) c+=2;
  if (st_B) c+=4;
  if (st_I) c+=8;

  *(lin + fsize + lsize + SIZE_X) = colort[c];
  lsize++;
  if (lsize>SIZE_X) lsize=SIZE_X;
}   
       
      
void DISPLAY::callback(ABSTIME time,EVENTID eventid)   {   
//  MessageBox(0, "callback", "Break", MB_OK);

}   
              
extern "C" IACTIVEMODEL __declspec(dllexport)*createactivemodel(CHAR *device,ILICENCESERVER *ils)  {    
        ils->authorize (0);     
        return new DISPLAY;   
}   
              
extern "C" VOID  __declspec(dllexport)deleteactivemodel (IACTIVEMODEL *model)  {    
    
    
  delete (DISPLAY*)model;   
}   
               
void DISPLAY::initialize(ICOMPONENT *cpt)  {    

}   
               
ISPICEMODEL *DISPLAY::getspicemodel(CHAR *)  {    
        return NULL;    
}   
       
IDSIMMODEL  *DISPLAY::getdsimmodel(CHAR *)  {      
        return this;    
}   

void DISPLAY::plot(ACTIVESTATE state)  {   

//  MessageBox(0, "plot", "Break", MB_OK);
}
        
void DISPLAY::animate(INT element, ACTIVEDATA *data)  {    
//  MessageBox(0, "animate", "Break", MB_OK);

}   

BOOL DISPLAY::actuate(WORD key, INT x, INT y, DWORD flags)  {
//  MessageBox(0, "ACTUATE2", "Break", MB_OK);
        return FALSE;    
}  
